﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BrushUpTeacherValidatorUnitTest
{
    public class Student
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public int Semester { get; set; }

        public void ValidateName()
        {
            // if (String.IsNullOrEmpty(Name)) throw new ArgumentException("Name is null or empty");

            if (Name == null) throw new ArgumentNullException("name is null");

            if (Name.Length < 1) throw new ArgumentException("name must be at least 1 character: " + Name);

        }

        public void ValidateSemester()
        {
            if (Semester < 1 || Semester > 8) throw new ArgumentOutOfRangeException("Semester must be minimum 1 and maximum 8: " + Semester);
        }

        public void Validate()
        {
            ValidateName();
            ValidateSemester();
        }

        public override string ToString()
        {
            return $"{{{nameof(Id)}={Id.ToString()}, {nameof(Name)}={Name}, {nameof(Semester)}={Semester.ToString()}}}";
        }
    }
}
